#!/usr/bin/perl -w

use strict;

if ($#ARGV != -1){
	print STDERR "\nUsage: $0\n\n";
	exit 1;
};

my @line;
my @odbor;
my %odbor_hash;
my $odbor_nazov;
my $odbor_cislo;
my $predmet_cislo;

LINE: while(<stdin>){
	chomp;
	if( $_ =~ /[0-9]{1,3}\s{1,3}[a-zA-Z0-9_\-\.]{1,3}\s{1,3}[0-9]{1,3}\s+[0-9]{3,6}\s+\-\s+.+/ ){
		$odbor_nazov= "";
		@odbor = split;
		$odbor_cislo = $odbor[3];
		for ( my $i = 5 ; $i <= $#odbor; $i ++ ){
			$odbor_nazov= $odbor_nazov . "$odbor[$i]";
			if( $odbor[$i+1] =~ /Poč\.pr:/ or $odbor[$i+1] =~ /Abs/ ){
				last;
			}
			$odbor_nazov= $odbor_nazov . " ";
		}
		$odbor_hash{$odbor_cislo} = $odbor_nazov;
	}
	if( $_ =~ /.+[0-9]{1,2}\-[0-9]{3,5}/ ){
		my $predmet_nazov = substr($_, 40); 
		$predmet_nazov = $` if $predmet_nazov =~ /\s+$/;
		# odrilovat pomlcky, lebo su rovnake nazvy len pomlcka je rozdiel
		$predmet_nazov =~ s/\s+\-\s+/ /g;

		my $predmet_kredity = substr($_, 35, 3); 
		$predmet_kredity =~ s/^\s+|\s+$//g;
		$predmet_kredity= 0 if not $predmet_kredity;

		my $predmet_hodiny = substr($_, 30, 3); 
		$predmet_hodiny =~ s/^\s+|\s+$//g;
		$predmet_hodiny = 0 if not $predmet_hodiny;

		my $predmet_typ = substr($_, 20, 3); 
		$predmet_typ =~ s/^\s+|\s+$//g;

		my $predmet_povinny = substr($_, 12, 3); 
		$predmet_povinny =~ s/^\s+|\s+$//g;

		#print "predmet_full_info: predmet_prve_cislo: " . substr($_, 4, 1) . "*predmet_druhe_cislo: " . substr($_, 6, 4) . "*nazov: $predmet_nazov*kredity: $predmet_kredity*predmet_hodiny: $predmet_hodiny*predmet_typ: $predmet_typ*predmet_povinny: $predmet_povinny*id_typ_urovne: 2*platny: 1*\n";
		print "predmet_full_info: predmet_prve_cislo: " . substr($_, 4, 1) . "*id_predmet: " . substr($_, 6, 4) . "*nazov: $predmet_nazov*kredity: $predmet_kredity*id_typ_urovne: 2*platny: 1*\n";
	}
}

while ( my ($key, $value) = each(%odbor_hash) ) {
	print "odbor_info: cislo_odboru: $key*nazov_odboru: $value*\n";
}
