#!/usr/bin/perl -w

use strict;
use Encode;

if ($#ARGV != -1){
	print STDERR "\nUsage: $0\n\n";
	exit 1;
};

my ($i, $j, $k, $m, $n, $x, $y);
my $line;
my $should_read = 1;
my $read_line_from_file;

my $datum_vytvorenia_match = 0;
my $datum_vytvorenia;

my $years_match= 0;
my $years;

my $os_cislo_match= 0;
my $os_cislo;

my $meno_match= 0;
my $meno;

my $datum_nar_match = 0;
my $datum_nar;

my $adresa_match= 0;
my $adresa;

my $stud_odbor_match= 0;
my $stud_odbor;

my $predmet_match= 0;
my $predmet;

my $bsp_match = 0;
my $bsp;

my $celkovy_pocet_predmetov_match =0;
my $celkovy_pocet_predmetov;

my $zapisane_kredity_match =0;
my $zapisane_kredity;

my $ziskane_kredity_match= 0;
my $ziskane_kredity;

# oddeluje prvu cast suboru, ktorej vycita datum vytvorenia suboru
my $start_of_file = 1;
# indikuje noveho studenta a vynechava opakujuce sa zaznamy na kazdej strane suboru
my $novy_student= 1;
# indikuju prave spracovavanu cast
my $top_file= 0;
my $middle_file = 0;
my $bottom_file= 0;
# indikuje prvy beh suboru, kedy netreba testovat vyplnenie bottom casti zaznamu pre studenta
my $first_run= 1;

my $rest_of_line;
my @predmet_info;
my @predmet_nazov_info;
my @predmet_cislo_info;
# indikuje, ze matchujeme dalsi riadok, ktory obsahuje dalsiu cast nazvu predmetu
#my $predmet_match_nextline;
my @stud_odbor_array;

sub Convert
{
	my $i_znamka = shift (@_);
	return "1,5" if ( $i_znamka =~ /výborne m\./ );
	return "1"   if ( $i_znamka =~ /výborne/ );
	return "2,5" if ( $i_znamka =~ /veľmi dobre m\./ );
	return "2"   if ( $i_znamka =~ /veľmi dobre/ );
	return "3,5" if ( $i_znamka =~ /dobre m\./ );
	return "3"   if ( $i_znamka =~ /dobre/ );
	return "4"   if ( $i_znamka =~ /dostatočne/ );
	return "5"   if ( $i_znamka =~ /nedostatočne/ );
	return "3"   if ( $i_znamka =~ /uspokojivo/ );
	return "5"   if ( $i_znamka =~ /neuspokojivo/ );
	return "0"   if ( $i_znamka =~ /započítané/ );

	return "1"   if ( $i_znamka =~ /A/ );
	return "1,5" if ( $i_znamka =~ /B/ );
	return "2"   if ( $i_znamka =~ /C/ );
	return "2,5" if ( $i_znamka =~ /D/ );
	return "3"   if ( $i_znamka =~ /E/ );
	return "4"   if ( $i_znamka =~ /F[xX]/ ); 
	return "no match for znamka";
}

sub Check_top_match{
	if ( not $top_file ){
		$top_file= 1;
		$middle_file= 0;
		$bottom_file = 0;
		if ( not( $datum_vytvorenia_match and $years_match and $os_cislo_match and $meno_match and $datum_nar_match and $adresa_match and $stud_odbor_match ) ) 
		{ 	
			die "\nError: Couldn't match one of mandatory fields from top of input file*\n"; 
		} else { 
			#$datum_vytvorenia_match = 0; netreba overovat zakazdym, nacitava sa iba raz
			$years_match = 0; 
			$os_cislo_match = 0; 
			$meno_match = 0; 
			$datum_nar_match = 0; 
			$adresa_match = 0; 
			$stud_odbor_match = 0; 
		};
	}
}

sub Check_middle_match{
	if ( not $middle_file ){
		$top_file= 0;
		$middle_file= 1;
		$bottom_file = 0;
		if ( not ( $predmet_match ) ){ 
			die "\nError: Couldn't match any predmet from middle of the file*\n"; 
		} else { 
			$predmet_match = 0 
		};
	}
}

sub Check_bottom_match{
	if ( not $bottom_file ){
		$top_file= 0;
		$middle_file= 0;
		$bottom_file = 1;
		if ( not ($bsp_match and $celkovy_pocet_predmetov_match and $zapisane_kredity_match and $ziskane_kredity_match) ){
			die "\nError: Couldn't match one of mandatory fields from bottom of input file*\n";
		}else{
			$bsp_match= 0;
			$celkovy_pocet_predmetov_match= 0;
			$zapisane_kredity_match = 0;
			$ziskane_kredity_match = 0;
		}
	}
}

sub Check_line{
	$line = shift @_;

	if ( $start_of_file ){
		if ($line =~ /ZÁPOČTOCH\s+[0-9]{1,2}\.[0-9]{1,2}\.[0-9]{4}/ ){
			$datum_vytvorenia= $& if $& =~ /[0-9]{1,2}\.[0-9]{1,2}\.[0-9]{4}/;
			$datum_vytvorenia_match= 1;
			print "file_info: datum_vytvorenia: $datum_vytvorenia*\n";
			$start_of_file= 0;
		}
	}

	if ($novy_student){
		if ($line =~ /[0-9]{4}\s+-\s+[0-9]{4}/){
			if ( not $first_run ){
				Check_bottom_match;
			}
			$years = $&; 
			$years_match= 1;
			print "student_info: years: $years*\n";
		}
	}

	if ($novy_student){
		if ($line =~ /Os\.čís\:\s+\S+/ ){
			if ( not $first_run ){
				Check_bottom_match;
			}
			$os_cislo = $' if $& =~ /\:\s+/;
			$os_cislo = $& if $os_cislo =~ /^\S+/;
			$os_cislo_match= 1;
			print "student_info: id_student: $os_cislo*\n";
			print "student_info: platny: 1*\n";
		}
	}

	if ($novy_student){
		if ($line =~ /Meno:\s+/) {
			if ( not $first_run ){
				Check_bottom_match;
			}
			$meno = $` if $' =~ /\s+Dátum\s+nar/;
			$meno_match= 1;
			my $priezvisko= $& if $meno =~ /[^\s]+/;
			my $prve_meno = $';
			# zrus medzery na zaciatku a na konci
			$priezvisko =~ s/^\s+|\s+$//g;
			$prve_meno =~ s/^\s+|\s+$//g;
			print "student_info: priezvisko: $priezvisko*\n";
			print "student_info: meno: $prve_meno*\n";
		}
	}

	if ($novy_student){
		if ($line =~ /Dátum\s+nar\.\:\s+/) {
			if ( not $first_run ){
				Check_bottom_match;
			}
			$datum_nar = $& if $' =~ /[0-9]{1,2}\.[0-9]{1,2}\.[0-9]{4}/;
			$datum_nar_match= 1;
			print "student_info: datum_nar: $datum_nar*\n";
		}
	}

	if ($novy_student){
		if ($line =~ /Adresa:\s+/){
			if ( not $first_run ){
				Check_bottom_match;
			}
			$adresa = $` if $' =~ /\s+$/;
			$adresa_match= 1;
			print "student_info: adresa: $adresa*\n";
		}
	}

	if ($novy_student){
		if ($line =~ /Štud\.\s+odbor:\s+/){
			if ( not $first_run ){
				Check_bottom_match;
			}
			$stud_odbor= $& if ($' =~ /[0-9]+\s+[0-9]+\s+.*/);
			$stud_odbor = $` if $stud_odbor =~ /\s+$/;
			@stud_odbor_array= split( /\s+/, $stud_odbor);
			$stud_odbor_match= 1;
			print "student_info: cislo_stud_odbor_1: $stud_odbor_array[0]*\n";
			print "student_info: cislo_stud_odbor_2: $stud_odbor_array[1]*\n";
			print "student_info: nazov_stud_odboru: ";
			for ( $i = 2 ; $i < $#stud_odbor_array; $i ++ ){
				print "$stud_odbor_array[$i] ";
			}
			print "$stud_odbor_array[$#stud_odbor_array]*\n";
		}
	}

# **************************************************
# znamky
# **************************************************

	if ($line =~ /[0-9]{1,2}\s{1,3}[0-9]{1,3}-[0-9]{1,6}\s{1,3}.+\/\S{1,3}/){
		my $znamka;
		my $datum_vykonania;
		my $match = $&;
		my $rest = $' if $' =~ /^\s+/;
		$first_run = 0;
		Check_top_match;
		$predmet = $` if $match =~ /(\s+\S{1,4}\/\S{1,4})$/;
		@predmet_info= split (/\s+/, $rest);
		@predmet_nazov_info = split ( /\s+/, $predmet);
		@predmet_cislo_info = split ( /\-/, $predmet_nazov_info[1] );

		print "predmet_info: os_cislo: $os_cislo*predmet_rocnik: $predmet_nazov_info[0]*predmet_prve_cislo: $predmet_cislo_info[0]*predmet_druhe_cislo: $predmet_cislo_info[1]*predmet_nazov: ";
		# v cykle vypiseme nazov predmetu, posledna cast nazvu predmetu urcite je v poslednom mieste pola
		for ( $i = 2 ; $i < $#predmet_nazov_info; $i ++){
			print "$predmet_nazov_info[$i] ";
		}
		print "$predmet_nazov_info[$#predmet_nazov_info]";
		# nacitame este jeden riadok, lebo dlhe nazvy predmetov su v dvoch riadkoch, ak to tak nieje, vykona sa normalny beh Check_line
		my $my_tmp_line= <stdin>;
		if( $my_tmp_line =~ /^( {10})[^\ ]{1}.*/ ){
			# zrus medzery na zaciatku a na konci
			$my_tmp_line =~ s/^\s+|\s+$//g;
			# nasledujuci cyklus by sa malo nacitavat zo suboru, kedze riadok sa spracoval
			$should_read = 1;

			print " $my_tmp_line";
		}else{
			# nasledujuci cyklus netreba nacitavat zo suboru, kedze riadok sa nespracoval
			$should_read = 0;
			# nacitany riadok bude my_tmp_line
			$read_line_from_file= $my_tmp_line;
		}
		print "*";

		print "prednasky: $predmet_info[0]*cvicenia: $predmet_info[1]*kredity: $predmet_info[2]*znak: $predmet_info[3]*";
		# v cykle poskladame nazov znamky, nevieme dopredu kde konci a doistoty koniec znamky matchujeme datumom ukoncenia
		for ( $i = 4 ; $i <= $#predmet_info; $i ++ ){
			if( $predmet_info[$i] =~ /[0-9]{1,2}\.[0-9]{1,2}\.[0-9]{2,4}/ ){
				$datum_vykonania= $predmet_info[$i];
			}else{
				$znamka = $znamka . "$predmet_info[$i] ";
			}
		}
		$znamka = $` if $znamka =~ /\s+$/;
		print "znamka: $znamka*konvertovana_znamka: " . Convert($znamka) . "*datum_vykonania: $datum_vykonania*\n";
		$predmet_match = 1;
		$novy_student = 0;
		return;
	}
	
# **************************************************
# koniec zaznamu, sumar
# **************************************************

	if ($line =~ /študijný\s+priemer:\s+/){
		Check_middle_match;
		$bsp = $& if ($' =~ /[0-9]+\.[0-9]+/);
		$bsp_match= 1;
		$novy_student= 1;
		$bsp=~ s/\./\,/g;
		print "student_info: bsp: $bsp*\n";
	}

	if ($line =~ /ukon\.\s+predmetov:\s+/){
		Check_middle_match;
		$celkovy_pocet_predmetov = $& if ($' =~ /[0-9]+/ );
		$celkovy_pocet_predmetov_match= 1;
		$novy_student= 1;
		print "student_info: celkovy_pocet_predmetov: $celkovy_pocet_predmetov*\n";
	}

	if ($line =~ /Zapísané\s+kredity:\s+/){
		Check_middle_match;
		$zapisane_kredity= $& if ($' =~ /[0-9]+\.[0-9]*/ );
		$zapisane_kredity_match= 1;
		$novy_student= 1;
		$zapisane_kredity =~ s/\./\,/g;
		print "student_info: zapisane_kredity: $zapisane_kredity*\n";
	}

	if ($line =~ /Získané\s+kredity:\s+/){
		Check_middle_match;
		$ziskane_kredity= $& if ($' =~ /[0-9]+\.[0-9]*/ );
		$ziskane_kredity_match= 1;
		$novy_student= 1;
		$ziskane_kredity =~ s/\./\,/g;
		print "student_info: ziskane_kredity: $ziskane_kredity*\n";
	}
}

for( ; ; ){
	# v procedure Check_line moze nastavit should_read na 0, ked netreba citat riadok, uz by mal byt nacitany v read_line_from_file
	if( $should_read ){
		$read_line_from_file = <stdin>;
	}
	# should_read niekedy ostane nastavene na 0, ked ziadny RE z procedury Check_line nematchne, preto preventivne nasledujuci cyklus nastavime na should_read =1;
	$should_read= 1;
	# koniec na konci suboru
	last if not $read_line_from_file;
	# zrus eol alebo nieco take
	chomp $read_line_from_file;

	Check_line( $read_line_from_file );
}

Check_bottom_match;
