#!/bin/bash

Usage() 
{
	echo "Usage $0 [-convert|-noconvert] [-parse_student|-no_parse_student] input_file odbor_file predmet_file predmet_info_file" >& 2;
	echo >& 2;
	echo "predmet_info.txt file must exist, must contain student, predmet and znamky and should come from ./parse_znamky.sh!" >& 2;
	echo >& 2;
	echo "Pri pouziti prepinaca -parse_student odparsuje aj predmety zo suboru pochadzajuceho so Studenta, kde sa daju zistit rozne predmety"
	exit 1
}

[ $# -eq 6 ] || Usage

if [[ "$1" = "-convert" ]] 
then 
	if [[ "$2" = "-parse_student" ]]
	then
		cat "$6" | tail +2 | cut -f3,4,5,8 -d';' | awk '// {split($0, my_a, /\;/); print "predmet_full_info: predmet_prve_cislo: "my_a[1]"*id_predmet: "my_a[2]"*nazov: "my_a[3]"*kredity: "my_a[4]"*id_typ_urovne: 2*platny: 1*"}' > temp1_"$5"
	fi

	cat "$3" | ./remove_bad_chars.sh | ./convert_encoding.sh  | ./_parse_predmety_odbory.pl >> temp1_"$5"
	cat temp1_"$5" | sort | uniq | ./split_odbor_predmet.sh temp_"$4" temp_"$5"

	cat temp_"$4" | ./choose_columns.pl > "$4"
	cat temp_"$5" | ./choose_columns.pl > "$5"

	rm temp_"$4"
	rm temp_"$5"
	rm temp1_"$5"

	if [ -n "`cat "$5" | cut -f2 -d';' | sort -n | uniq -D`" ]
	then
		echo "Warning: cislo predmetu nieje jednoznacne, odstran duplicity!" >& 2
	fi

	exit 0
fi

if [[ "$1" = "-noconvert" ]] 
then
	if [[ "$2" = "-parse_student" ]]
	then
		# vyparsuj subor s predmetmi do tmp
		cat "$6" | tail +2 | cut -f3,4,5,8 -d';' | awk '// {split($0, my_a, /\;/); print "predmet_full_info: predmet_prve_cislo: "my_a[1]"*id_predmet: "my_a[2]"*nazov: "my_a[3]"*kredity: "my_a[4]"*id_typ_urovne: 2*platny: 1*"}' > temp1_"$5"
	fi

	# doloz tam dalsie predmety
	cat "$3" | ./remove_bad_chars | ./_parse_predmety_odbory.pl >> temp1_"$5"
	# usortuj a zjunikuj
	cat temp1_"$5" | sort | uniq | ./split_odbor_predmet.sh temp_"$4" temp_"$5"

	cat temp_"$4" | ./choose_columns.pl > "$4"
	cat temp_"$5" | ./choose_columns.pl > "$5"

	rm temp_"$4"
	rm temp_"$5"
	rm temp1_"$5"

	if [ -n "`cat "$5" | cut -f2 -d';' | sort -n | uniq -D`" ]
	then
		echo "Warning: cislo predmetu nieje jednoznacne, odstran duplicity!" >& 2
	fi

	exit 0
fi

Usage
